#include "appwindow.h"
#include "keyblogger.h"
#include "fpscounter.h"
#include "sharedstructs.h"
#include <linux/input.h>

#define EV_RELEASED 0
#define EV_PRESSED 1

static int keybd_fd = 0;

/** Accesses the keyboard to read raw keyboard events */
int init_keyb_logging(const char* evdev_path)
{
  keybd_fd = open(evdev_path, O_RDONLY);
  
  if (keybd_fd < 0) {
    fprintf(stderr, "CRITICAL: Cannot open %s for reading. Check permissions.\n", evdev_path);
    return -1;
  }
  
  return 0;
}

/** Keyboard event loop */
void* get_keyb_events(void* args)
{
  exit_thrdata* etd = (exit_thrdata*)args;
  struct input_event ev;
  int run_loop = 1;
  
  while (run_loop) {
    read(keybd_fd, &ev, sizeof(struct input_event));
    if (ev.type == EV_KEY) {
      if (ev.code == 87 && ev.value == EV_PRESSED) {
	start_stop_benchmark();
      }
    }

    pthread_mutex_lock(etd->exit_mutex);
    if (*(etd->pexit_app) == 1)
      run_loop = 0;
    pthread_mutex_unlock(etd->exit_mutex);
  }

  return NULL;
}
